#!/bin/bash

mkdir extracted_data

echo "computing assignment overlap with google"
cat data/pass-1 | python scripts/extraction/googtrans-over-assigns.py > extracted_data/googmatch.assigns.txt
echo "computing turker overlap with google"
python scripts/extraction/googtrans-over-turkers.py > extracted_data/googmatch.turkers.txt
echo "computing language overlap with google"
python scripts/extraction/googtrans-over-langs.py > extracted_data/googmatch.langs.txt

echo "computing assignment quality scores"
python scripts/extraction/quality-over-assigns.py > extracted_data/quality.assigns.txt 
echo "computing turker quality scores"
python scripts/extraction/quality-over-turkers.py > extracted_data/quality.turkers.txt 
echo "computing language quality scores"
python scripts/extraction/quality-over-langs.py > extracted_data/quality.langs.txt 


