#!/bin/python

#99682	pam	bren	NA	NA	4747:Bren	3275:Barack Obama	2481:bren
#lang	worker	num_hits	quality	quality_syn	num_langs	goog

import sys
import csv

if len(sys.argv) < 2 : 
	sys.stderr.write("USAGE: cat data/pass-1 | python get_dictionary.py LANGUAGE MIN_QUALITY\n")
	exit(0)

lang = sys.argv[1]
q = float(sys.argv[2])

turker_data = csv.DictReader(open('extracted_data/quality.turkers.txt'), delimiter='\t')
turker_qualities = {line['worker'] : float(line['quality_syn']) for line in turker_data if line['lang'] == lang}

dictionary = {}

for line in sys.stdin : 
	id, tlang, word, google, control, translations = line.strip().split('\t',5)
	word = word.strip().lower()
	if word == '' : continue
	if tlang == lang : 
		for wt in translations.split('\t') :
			w, t = wt.split(':', 1)
			t = t.strip().lower()
			if t == '' : continue
			if w in turker_qualities : 
				if turker_qualities[w] >= q : 
					if word not in dictionary : dictionary[word] = set()
					dictionary[word].add(t.replace('\t',' '))

for word in sorted(dictionary.keys()): 
	print '%s\t%s'%(word, '\t'.join(list(dictionary[word])))

