#!/bin/python

#lang	assign	worker	overall	overall-ng	num-correct	num-total	num-correct-ng	num-total-ng	status
#gu	267659	1416	0.500	0.500	1.000	2.000	1.000	2.000	approved

import sys
import csv
from settings import settings

byworker = {}

turkers = {row['worker'] : row for row in csv.DictReader(open('extracted_data/googmatch.turkers.txt'), delimiter='\t')}

for line in csv.DictReader(open('extracted_data/quality.assigns.txt'), delimiter='\t'):
	lang = line['lang']
	worker = line['worker'];
	overall = line['overall']
	overall_syn = line['overall-syn']

	if lang not in byworker: byworker[lang] = {}
	if worker not in byworker[lang] : byworker[lang][worker] = {'correct' : 0 , 'correct-syn' : 0, 'total' : 0, }

	byworker[lang][worker]['correct'] += float(overall)
	byworker[lang][worker]['correct-syn'] += float(overall_syn)
	byworker[lang][worker]['total'] += 1

print 'lang\tworker\tnum_hits\tquality\tquality_syn\tgoog'
for lang in byworker:
	for worker in byworker[lang]:
		quality = float(byworker[lang][worker]['correct'])/byworker[lang][worker]['total']
		quality_syn = float(byworker[lang][worker]['correct-syn'])/byworker[lang][worker]['total']

		num_hits = byworker[lang][worker]['total']
		goog = float(turkers[worker]['match'])

		params = (lang,worker,num_hits,quality,quality_syn,goog)

		print '%s\t%s\t%d\t%.03f\t%.03f\t%s'%params
