#!/bin/python
import csv
import math
import operator
import itertools
import numpy as np
import sys
sys.path.append('scripts/extraction')
from settings import settings
from scipy import stats
from scipy.stats import ttest_1samp
import matplotlib.pyplot as plt

data = {}
all_data = []

NH=0
sz=10

goog_langs = ['el', 'eo', 'zh', 'af', 'vi', 'is', 'it', 'kn', 'cs', 'cy', 'ar', 'eu', 'et', 'gl', 'id', 'es', 'ru', 'az', 'nl', 'pt', 'tr', 'lv', 'lt', 'th', 'gu', 'ro', 'ca', 'pl', 'ta', 'fr', 'bg', 'ms', 'hr', 'de', 'da', 'fa', 'fi', 'hy', 'hu', 'ja', 'he', 'te', 'sr', 'sq', 'ko', 'sv', 'ur', 'sk', 'uk', 'sl', 'sw']

def batch(iterable, n = 3):
	l = len(iterable)
	for ndx in range(0, l, n):
		yield iterable[ndx:min(ndx+n, l)]

gmatch = csv.DictReader(open('extracted_data/googmatch.turkers.txt'), delimiter='\t')

tot = 0.0
ftot = 0.0
fnum = 0.0

worker_gmatch = [] 
for line in gmatch : 
	w = line['worker']; l = line['lang']; m = float(line['match'])
	if float(line['num_hits']) < NH : continue
	if l not in goog_langs : continue
	worker_gmatch.append((w,l,m))
	tot += m
	if m < 0.7 : ftot += m; fnum += 1;


graph_data = [] 
#for worker,lang,m in sorted(worker_gmatch, key=operator.itemgetter(2), reverse=True):
for b in batch(sorted(worker_gmatch, key=operator.itemgetter(2), reverse=True),n=sz):
	graph_data.append(sum([e[2] for e in b]) / sz)

graph_data = sorted(graph_data, reverse=True)

plt.fill_betweenx(graph_data, (500/sz), color='#6699FF', alpha='0.4')
#plt.fill_betweenx(graph_data, (500/sz), color='#0000FF', alpha='0.4')
is_zero = [(float(e) < 0.05) for e in graph_data].index(True)
plt.fill_betweenx(graph_data, is_zero, len(graph_data), color='#6699FF', alpha='0.4')
#plt.fill_betweenx(graph_data, is_zero, len(graph_data), color='#0000FF', alpha='0.4')

plt.vlines(range(len(graph_data)), [0 for t in graph_data], graph_data, color='#0000FF', linestyles='solid')
#plt.vlines(range(len(graph_data)), [0 for t in graph_data], graph_data, linestyles='solid')
plt.ylabel('Overlap with Google')
plt.ylim(0,max(graph_data))
plt.xlim(0,len(graph_data))
plt.xticks(range(0,len(graph_data),50),[str(i) for i in range(0,len(worker_gmatch),50*sz)])
plt.show()
#plt.savefig('turker-googmatch-distribution.pdf')
